/*
  monaka.h
*/

/* チャッタリング防止用にキーを読み込む待ち時間 */
#define KEY_COUNT_TH 200

/* トリガモードの場合のパルス幅(カウント数) */
#define TRIG_WIDTH 100

/* LED,KEYスキャンのカウント値 */
#define SCAN_COUNT_TH 10

#define setPortBit0(port, bit) *(port) &= ~_BV(bit);
#define setPortBit1(port, bit) *(port) |= _BV(bit);

#define setPortBit(port, bit, val) { \
    if ((val) == 0) { setPortBit0((port), (bit)); } else	\
      { setPortBit1((port), (bit)); }				\
}
#define getPortBit(port, bit) ((*(port) & _BV(bit)) >> (bit))

#define flipPortBit(port, bit) (*(port) ^= _BV(bit))

extern void keyEventAppend(uchar, uchar);
extern void parseMidiMessage(uchar *, uchar);
extern void initializeKeyStatus(void);
extern void polyOutInit();

extern uint16_t getTp(uchar);

const prog_uint16_t freq_table[] ;
